"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var getPath = function getPath(obj, arPath) {
  var res = obj;
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = arPath[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var sub = _step.value;
      res = res[sub];
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return != null) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return res;
};

var setPath = function setPath(obj, _arPath, data) {
  if (1 < _arPath.length) {
    var subPath = _arPath.slice(0, _arPath.length - 1);

    var lastSubPath = _arPath[_arPath.length - 1];
    var subObj = getPath(obj, subPath);
    subObj[lastSubPath] = data;
  } else if (_arPath.length === 1) {
    obj[_arPath[0]] = data;
  }
};

var getQueryPaths = function getQueryPaths(query) {
  var definitions = query.definitions;
  var pathEdges = [];
  var pathPageInfo = [];
  var pathItem = [];
  var haveEdges = false;
  var havePageInfo = false; //let haveItem = false
  //console.log(query.definitions)

  var _iteratorNormalCompletion2 = true;
  var _didIteratorError2 = false;
  var _iteratorError2 = undefined;

  try {
    for (var _iterator2 = definitions[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
      var def = _step2.value;

      if (def.operation === "query") {
        var _iteratorNormalCompletion3 = true;
        var _didIteratorError3 = false;
        var _iteratorError3 = undefined;

        try {
          for (var _iterator3 = def.selectionSet.selections[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
            var sel = _step3.value;
            var directiveConnection = false;
            var _iteratorNormalCompletion4 = true;
            var _didIteratorError4 = false;
            var _iteratorError4 = undefined;

            try {
              for (var _iterator4 = sel.directives[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
                var dir = _step4.value;

                if (dir.name.value === "connection") {
                  directiveConnection = true;
                  break;
                }
              }
            } catch (err) {
              _didIteratorError4 = true;
              _iteratorError4 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion4 && _iterator4.return != null) {
                  _iterator4.return();
                }
              } finally {
                if (_didIteratorError4) {
                  throw _iteratorError4;
                }
              }
            }

            if (!directiveConnection) {
              throw new Error('Query must contain directive @connection(key: "????")');
            }

            if (directiveConnection) {
              pathEdges.push(sel.name.value);
              pathPageInfo.push(sel.name.value);
              var _iteratorNormalCompletion5 = true;
              var _didIteratorError5 = false;
              var _iteratorError5 = undefined;

              try {
                for (var _iterator5 = sel.selectionSet.selections[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
                  var sel2 = _step5.value;

                  if (sel2.name.value === "edges") {
                    pathEdges.push(sel2.name.value);
                    haveEdges = true;
                    var _iteratorNormalCompletion6 = true;
                    var _didIteratorError6 = false;
                    var _iteratorError6 = undefined;

                    try {
                      for (var _iterator6 = sel2.selectionSet.selections[Symbol.iterator](), _step6; !(_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done); _iteratorNormalCompletion6 = true) {
                        var sel3 = _step6.value;

                        if (sel3.name.value === "node") {
                          pathItem.push(sel3.name.value); //haveItem = true

                          break;
                        }
                      }
                    } catch (err) {
                      _didIteratorError6 = true;
                      _iteratorError6 = err;
                    } finally {
                      try {
                        if (!_iteratorNormalCompletion6 && _iterator6.return != null) {
                          _iterator6.return();
                        }
                      } finally {
                        if (_didIteratorError6) {
                          throw _iteratorError6;
                        }
                      }
                    }
                  } else if (sel2.name.value === "pageInfo") {
                    pathPageInfo.push(sel2.name.value);
                    havePageInfo = true;
                  }

                  if (haveEdges && havePageInfo) {
                    break;
                  }
                }
              } catch (err) {
                _didIteratorError5 = true;
                _iteratorError5 = err;
              } finally {
                try {
                  if (!_iteratorNormalCompletion5 && _iterator5.return != null) {
                    _iterator5.return();
                  }
                } finally {
                  if (_didIteratorError5) {
                    throw _iteratorError5;
                  }
                }
              }
            }

            if (haveEdges && havePageInfo) {
              break;
            }
          }
        } catch (err) {
          _didIteratorError3 = true;
          _iteratorError3 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion3 && _iterator3.return != null) {
              _iterator3.return();
            }
          } finally {
            if (_didIteratorError3) {
              throw _iteratorError3;
            }
          }
        }
      }

      if (haveEdges && havePageInfo) {
        break;
      }
    } //const fnGetEdges = (data) => data.feedConnection.edges

  } catch (err) {
    _didIteratorError2 = true;
    _iteratorError2 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion2 && _iterator2.return != null) {
        _iterator2.return();
      }
    } finally {
      if (_didIteratorError2) {
        throw _iteratorError2;
      }
    }
  }

  var fnGetEdges = function fnGetEdges(data) {
    return getPath(data, pathEdges);
  }; //const fnSetEdges = (data, edges) => { data.feedConnection.edges = edges }


  var fnSetEdges = function fnSetEdges(data, edges) {
    setPath(data, pathEdges, edges);
  }; //  const fnGetItem = (edge) => edge.node


  var fnGetItem = function fnGetItem(edge) {
    return getPath(edge, pathItem);
  };

  var fnGetPageInfo = function fnGetPageInfo(data) {
    return getPath(data, pathPageInfo);
  };

  var fnGetArray = function fnGetArray(data) {
    return fnGetEdges(data).map(function (o) {
      return fnGetItem(o);
    });
  }; // const fnGetArray = data => {
  //   console.log(`fnGetArray`)
  //   console.log(data)
  //   console.log(fnGetEdges(data))
  //   console.log(fnGetEdges(data).map(o => fnGetItem(o)))
  //   return fnGetEdges(data).map(o => fnGetItem(o))
  // }


  var fnJoinResults = function fnJoinResults(currData, prevData) {
    return fnSetEdges(currData, fnGetEdges(prevData).concat(fnGetEdges(currData)));
  };

  return {
    //fnGetEdges,
    //fnSetEdges,
    fnJoinResults: fnJoinResults,
    //fnGetItem,
    fnGetArray: fnGetArray,
    fnGetPageInfo: fnGetPageInfo
  };
};

var _default = getQueryPaths;
exports.default = _default;